package code{
   import flash.display.*;
   import flash.events.*;
   import flash.text.*;
   import flash.utils.setInterval;

   public class Framerate extends Sprite {
      private var fps_txt = new TextField();
      public var fps =0;
      private var elapsedTime:uint = 0;
      private var fpsInterval:uint; /// = setInterval(calculate_framerate, 500);
      private  var format:TextFormat = new TextFormat();
      //constructor
      public function Framerate():void {
         initialize();
      }

      private function initialize():void {
         fps_txt.autoSize = TextFieldAutoSize.LEFT;
         fps_txt.background = false;
         fps_txt.selectable = false;
         format.font = "Tahoma";
         format.color = 0xFFFFFF;
         format.size = 10;
         fps_txt.defaultTextFormat = format;
         fps_txt.text = "Calculating FPS";
         addChild(fps_txt);
         fpsInterval = setInterval(calculate_framerate, 250);
         addEventListener(Event.ENTER_FRAME, frameRateonEnterFrame);
      }

      private function calculate_framerate():void {
         fps_txt.text = (elapsedTime * 4) + " fps";
         fps = elapsedTime * 4;
         elapsedTime=0;
      }

      public function setTextColor(in_num)
      {
          format.color = in_num;
          fps_txt.defaultTextFormat = format;
      }

      private function frameRateonEnterFrame(ev:Event):void {
         elapsedTime++;
      }
   }
}
