package code
{
   import code.*;
   import flash.display.MovieClip;
   import flash.display.SimpleButton;
   import flash.events.MouseEvent;
   import flash.events.KeyboardEvent;
   import flash.events.Event;
   import flash.events.TimerEvent;
   import flash.display.*;
   import flash.utils.Timer;

   public class KeyListener extends MovieClip
   {
      public function KeyListener(){ };
      
      public function startControls(){
         this.stage.addEventListener("keyDown", reportKeyDown)
      }
      
      public function reportKeyDown(event:KeyboardEvent):void {
          Main.keyEntered(decodeKeyCode(event.keyCode));
      }

      public function decodeKeyCode(in_num:Number):String
      {
         switch(in_num)
         {
            case(65): // A
               return "a";
            break;
            case(66): // B
               return "b";
            break;
            case(67):
               return "c";
            break;
            case(68):
               return "d";
            break;
            case(69):
               return "e";
            break;
            case(70):
               return "f";
            break;
            case(71):
               return "g";
            break;
            case(72):
               return "h";
            break;
            case(73):
               return "i";
            break;
            case(74):
               return "j";
            break;
            case(75):
               return "k";
            break;
            case(76):
               return "l";
            break;

            case(77):
               return "m";
            break;
            case(78):
               return "n";
            break;
            case(79):
               return "o";
            break;
            case(80):
               return "p";
            break;
            case(81):
               return "q";
            break;
            case(82):
               return "r";
            break;
            case(83):
               return "s";
            break;
            case(84):
               return "t";
            break;
            case(85):
               return "u";
            break;
            case(86):
               return "v";
            break;

            case(87):
               return "w";
            break;
            case(88):
               return "x";
            break;
            case(89):
               return "y";
            break;
            case(90):
               return "z";
            break;

            case(48):
               return "0";
            break;
            case(49):
               return "1";
            break;
            case(50):
               return "2";
            break;
            case(51):
               return "3";
            break;
            case(52):
               return "4";
            break;
            case(53):
               return "5";
            break;
            case(54):
               return "6";
            break;
            case(55):
               return "7";
            break;
            case(56):
               return "8";
            break;
            case(57):
               return "9";
            break;


            case(96):
               return "Numpad 0";
            break;
            case(97):
               return "Numpad 1";
            break;
            case(98):
               return "Numpad 2";
            break;
            case(99):
               return "Numpad 3";
            break;
            case(100):
               return "Numpad 4";
            break;
            case(101):
               return "Numpad 5";
            break;
            case(102):
               return "Numpad 6";
            break;
            case(103):
               return "Numpad 7";
            break;
            case(104):
               return "Numpad 8";
            break;
            case(105):
               return "Numpad 9";
            break;
            case(106):
               return "Numpad *";
            break;
            case(107):
               return "Numpad +";
            break;
            case(13):
               return "Enter";
            break;
            case(109):
               return "Numpad -";
            break;
            case(110):
               return "Numpad .";
            break;
            case(111):
               return "Numpad /";
            break;

            case(112):
               return "F1";
            break;
            case(113):
               return "F2";
            break;
            case(114):
               return "F3";
            break;
            case(115):
               return "F4";
            break;
            case(116):
               return "F5";
            break;
            case(117):
               return "F6";
            break;
            case(118):
               return "F7";
            break;
            case(119):
               return "F8";
            break;
            case(120):
               return "F9";
            break;
            //f10 is reserved by the system
            case(122):
               return "F11";
            break;
            case(123):
               return "F12";
            break;

            case(8):
               return "Backspace";
            break;
            case(9):
               return "Tab";
            break;
            case(16):
               return "Shift";
            break;
            case(17):
               return "Control";
            break;
            case(20):
               return "Caps Lock";
            break;
            case(27):
               return "Esc";
            break;
            case(32):
               return "Spacebar";
            break;
            case(33):
               return "Page Up";
            break;
            case(34):
               return "Page Down";
            break;
            case(35):
               return "End";
            break;
            case(36):
               return "Home";
            break;
            case(37):
               return "Left Arrow";
            break;
            case(38):
               return "Up Arrow";
            break;
            case(39):
               return "Right Arrow";
            break;
            case(40):
               return "Down Arrow";
            break;
            case(45):
               return "Insert";
            break;
            case(46):
               return "Delete";
            break;
            case(144):
               return "Num Lock";
            break;
            case(145):
               return "Scroll Lock";
            break;
            case(19):
               return "Pause/Break";
            break;
            
            case(186):
               return ";";
            break;
            case(187):
               return "=";
            break;
            case(189):
               return "-";
            break;
            case(191):
               return "/";
            break;
            case(192):
               return "`";
            break;
            case(219):
               return "[";
            break;
            case(220):
               return "\\";
            break;
            case(221):
               return "]";
            break;
            case(222):
               return "'";
            break;
            case(188):
               return ",";
            break;
            case(190):
               return ".";
            break;
            case(191):
               return "/";
            break;
            default:
               //trace("unassigned " + in_num);
               return "Unassigned";
         }
      }      
   }//end class
}

