package code
{
   import code.*;
   import flash.display.MovieClip;
   import flash.events.*;
   import flash.display.*;
   import flash.utils.Timer;
   import flash.media.Sound;
   import flash.media.SoundChannel;
   import flash.media.SoundTransform;
   import flash.net.URLRequest;
   import flash.net.URLRequest;

   public class BGM extends MovieClip
   {
      public static var  bgChannel:SoundChannel;
      public static var  bgTransform:SoundTransform;
      public var sdVolume =.6;
      public var sdVolMax =.6;     
      public var speakerOn =true; //true means on  
      public var gameBGM = new sd_BGM();
            
      public function BGM()
      {
         this.addEventListener(MouseEvent.ROLL_OVER, m_BGM_rollOver);
         this.addEventListener(MouseEvent.ROLL_OUT, m_BGM_rollOut);
         this.addEventListener(MouseEvent.CLICK, m_audioClick);
      }
      
      public function m_BGM_rollOver(event:Event){ 
         if(speakerOn)
            gotoAndPlay("over");
      }
      
      public function m_BGM_rollOut(event:Event){
         if(speakerOn)
            gotoAndPlay("out");
      }  

      public function m_audioClick(e:Event){
         if(speakerOn)
         {
            speakerOn = false;
            gotoAndStop("disable");
            stopBGM();
         }
         else
         {
            speakerOn = true;
            gotoAndStop("up");
            playBGM();
         }
      }
      public function stopBGMImmediate()
      {
         try{bgChannel.stop();}catch(e:Error){}
      }
 
      //sound stuff
      public function stopBGM()
      {
         sdVolume=sdVolMax;
         addEventListener(Event.ENTER_FRAME, soundFadeOut);
      }

      public function playBGM()
      {
         if(bgChannel != null)
            bgChannel.stop();

          if(speakerOn)
          {
            //no fadeIn cause music already sorts of does that
            bgChannel = gameBGM.play();
            bgChannel.addEventListener(Event.SOUND_COMPLETE, soundCompleteHandler);
          
            bgTransform= bgChannel.soundTransform;
            sdVolume=sdVolMax;
            bgTransform.volume = sdVolume;
            bgChannel.soundTransform = bgTransform;
              
         }
      }
      
      public function soundCompleteHandler(e:Event){
         playBGM();
      }
           
      public function soundFadeOut(event:Event):void
      {
         if(sdVolume > 0)
         {
            bgTransform.volume = sdVolume;
            bgChannel.soundTransform = bgTransform;
            sdVolume -=.02;
         }
         else
         {
            sdVolume=sdVolMax;
            bgChannel.stop();
            removeEventListener(Event.ENTER_FRAME, soundFadeOut);
         }
      }
  
   }//end class
}